/// <reference path="AccessKeyedElement.d.ts" />
/// <reference path="ButtonElement.d.ts" />
/// <reference path="ClippableElement.d.ts" />
/// <reference path="DraggableElement.d.ts" />
/// <reference path="DraggableGroupElement.d.ts" />
/// <reference path="FlaggedElement.d.ts" />
/// <reference path="FloatableElement.d.ts" />
/// <reference path="GroupElement.d.ts" />
/// <reference path="IconElement.d.ts" />
/// <reference path="IndicatorElement.d.ts" />
/// <reference path="LabelElement.d.ts" />
/// <reference path="LookupElement.d.ts" />
/// <reference path="PendingElement.d.ts" />
/// <reference path="PopupElement.d.ts" />
/// <reference path="RequestManager.d.ts" />
/// <reference path="RequiredElement.d.ts" />
/// <reference path="TabIndexedElement.d.ts" />
/// <reference path="TitledElement.d.ts" />

declare namespace OO.ui {
    /**
     * Namespace for OOUI mixins.
     *
     * Mixins are named according to the type of object they are intended to
     * be mixed in to. For example, {@link OO.ui.mixin.GroupElement} is intended to be
     * mixed in to an instance of {@link OO.ui.Element}, and {@link OO.ui.mixin.GroupWidget}
     * is intended to be mixed in to an instance of {@link OO.ui.Widget}.
     *
     * ResourceLoader module: `oojs-ui-core`
     *
     * @see https://doc.wikimedia.org/oojs-ui/master/js/#!/api/OO.ui.mixin
     */
    namespace mixin {}
}
